require "defines"

local effectSize = 15

local deforesters = {}
local timer = 0

script.on_event(defines.events.on_built_entity, function(event)
	if event.created_entity.name == "deforester" then
		table.insert(deforesters, event.created_entity)
	end
  end)

script.on_event(defines.events.on_robot_built_entity, function(event)
	if event.created_entity.name == "deforester" then
		table.insert(deforesters, event.created_entity)
	end
  end)
  
script.on_event(defines.events.on_tick, function(event)
	if timer > 100 then
		for _,entity in pairs(deforesters) do 
			if entity.valid then
				local position = entity.position
				local trees = game.get_surface(1).find_entities_filtered{area = {{position.x - effectSize, position.y - effectSize}, {position.x + effectSize, position.y + effectSize}}, type= "tree"}
				for key,tree in pairs(trees) do
					tree.damage(1, game.player.force)
				end
			end
		end
		timer = 0
	end
	timer = timer + 1
end)

script.on_event(defines.events.on_player_mined_item, function(event)
	removeDeforester(event.entity)
end)

script.on_event(defines.events.on_robot_mined, function(event)
	removeDeforester(event.entity)
end)
script.on_event(defines.events.on_entity_died, function(event)
	removeDeforester(event.entity)
end)

function removeDeforester(eventEntity)
	for key,entity in pairs(deforesters) do
		if entity == eventEntity then
			table.remove(deforester, key)
		end
	end
end
	
function table.contains(table, element)
  for _, value in pairs(table) do
    if value == element then
      return true
    end
  end
  return false
end